#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <i86.h>                // needed for OpenWatcom
#include "defines.h"

#define PURPOSE "\nTest of PCF8591\n"

#define PCF8591_addr 0x90       // Device Addr = 0
#define PCF8591_conf 0x40

byte_t config, adc_value, dac_value = 0;

void status_LED(byte_t state);
boolean_t getADC(byte_t config, byte_t * adc_value);
boolean_t putDAC(byte_t dac_value);

int main(void)
{
    printf(PURPOSE);
    while (!kbhit())
    {
        if (!putDAC(dac_value))
      {
        delay(100);
        status_LED(ON);                 // Status LED on
         delay(100);
         if (!getADC(PCF8591_conf, & adc_value))
         {
                printf("%02X\t%02X\t%4d\n", dac_value, adc_value, adc_value-dac_value);
         }
         status_LED(OFF);
      }
      dac_value++;
      
    }
    printf("\nProgram finished.\n");
    system("PAUSE"); // for test on PC only
    return 0;
}

void status_LED(byte_t state)
{
   outp(0x334, state);
}

boolean_t putDAC(byte_t dac_value)
{
   inregs.w.ax = 0xC32D;                   // printf("%04X ", inregs.x.ax);
   inregs.h.ch = PCF8591_addr;  // printf("%02X ", inregs.h.ch);
   inregs.h.bh = PCF8591_conf;   // printf("%02X ", inregs.h.bh);
   inregs.h.bl = dac_value;      // printf("%02X\t", inregs.h.bl);
   int386(0x15, &inregs, &outregs);
   return outregs.w.cflag;
}

boolean_t getADC(byte_t config, byte_t * adc_value)
{
   boolean_t flag;

   inregs.w.ax = 0xC32B;         // printf("%04X ", inregs.x.ax);
   inregs.h.ch = PCF8591_addr;   // printf("%02X ", inregs.h.ch);
   inregs.h.bl = config;                        // printf("%02X ", inregs.h.bl);
   int386(0x15, &inregs, &outregs);
   flag = outregs.x.cflag;

   inregs.w.ax = 0xC32C;         // printf("%04X ", inregs.x.ax);
   inregs.h.ch = PCF8591_addr;   // printf("%02X ", inregs.h.ch);
   int386(0x15, &inregs, &outregs);
   * adc_value = outregs.h.al;   // printf("%02X ", outregs.h.ah); printf("%02X\t", outregs.h.al);
   return outregs.x.cflag || flag;
}
